//+------------------------------------------------------------------+
//|                                                       RSI+MA.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property copyright "Copyright  2010, modified by LenIFCHIK"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 RoyalBlue             //  RSI               
#property indicator_color2  Red                  //  MA
#property indicator_level1 70
#property indicator_level2 30 
//----  
extern int RSIPeriod=14;
extern int MAPeriod=3;
extern int MAShift=3;
extern string ____MA_calculation_method____="___ 0-simple, 1-exponential ___";
extern int MA_method=0;
//---- 
double RSIBuffer[];
double MABuffer[];
double PosBuffer[];
double NegBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name, rsi_short_name, ma_short_name;
//---- 2     
   IndicatorBuffers(4);
   SetIndexBuffer(2,PosBuffer);
   SetIndexBuffer(3,NegBuffer);
//----   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,RSIBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MABuffer);
//---- ,   DataWindow
   switch(MA_method)
         {
          case 0:                                                               
          short_name="RSI("+RSIPeriod+")+SMA("+MAPeriod+","+MAShift+")";
          ma_short_name="SMA("+MAPeriod+","+MAShift+")";
          break;
          case 1:
          short_name="RSI("+RSIPeriod+")+EMA("+MAPeriod+","+MAShift+")";
          ma_short_name="EMA("+MAPeriod+","+MAShift+")";
          break;
         }
   rsi_short_name="RSI("+RSIPeriod+")";   
   IndicatorShortName(short_name);
   SetIndexLabel(0,rsi_short_name);
   SetIndexLabel(1,ma_short_name);
//----  
   SetIndexDrawBegin(0,RSIPeriod);
   SetIndexDrawBegin(1,RSIPeriod+MAPeriod);
//----   
   SetIndexShift(1,MAShift);
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i,counted_bars=IndicatorCounted();
   double rel,negative,positive,ma;
   if(Bars<=RSIPeriod) return(0);
   if(counted_bars<1)
      for(i=1;i<=RSIPeriod;i++) RSIBuffer[Bars-i]=0.0;
   i=Bars-RSIPeriod-1;
   if(counted_bars>=RSIPeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {
      double sumn=0.0,sump=0.0;
      if(i==Bars-RSIPeriod-1)
        {
         int k=Bars-2;
         while(k>=i)
           {
            rel=Close[k]-Close[k+1];
            if(rel>0) sump+=rel;
            else      sumn-=rel;
            k--;
           }
         positive=sump/RSIPeriod;
         negative=sumn/RSIPeriod;
        }
      else
        {
         rel=Close[i]-Close[i+1];
         if(rel>0) sump=rel;
         else      sumn=-rel;
         positive=(PosBuffer[i+1]*(RSIPeriod-1)+sump)/RSIPeriod;
         negative=(NegBuffer[i+1]*(RSIPeriod-1)+sumn)/RSIPeriod;
        }
      PosBuffer[i]=positive;
      NegBuffer[i]=negative;
      if(negative==0.0) RSIBuffer[i]=0.0; 
      else RSIBuffer[i]=100.0-100.0/(1+positive/negative);     
      i--;
     }
//----     RSI    
   i=Bars-RSIPeriod-1;
   if(counted_bars>=RSIPeriod) i=Bars-counted_bars-1;
   switch(MA_method)
      {
         //----    
         case 0:    
            double sum=0;
            int pos=Bars-counted_bars-1;
            if(pos<MAPeriod) pos=MAPeriod;
            for(i=1;i<MAPeriod;i++,pos--)
               sum+=RSIBuffer[pos];
            while(pos>=0)
               {
                  sum+=RSIBuffer[pos];
                  MABuffer[pos]=sum/MAPeriod;
	               sum-=RSIBuffer[pos+MAPeriod-1];
 	               pos--;
               }
            if(counted_bars<1)
               for(i=1;i<MAPeriod;i++) MABuffer[Bars-i]=0;
            break;
         //----   
         case 1:
            double pr1=2.0/(MAPeriod+1);
            int    pos1=Bars-2;
            if(counted_bars>2) pos1=Bars-counted_bars-1;
            while(pos1>=0)
               {
                  if(pos1==Bars-2) 
                     {
                        MABuffer[pos1+1]=RSIBuffer[pos1+1];
                     }
                  MABuffer[pos1]=RSIBuffer[pos1]*pr1+MABuffer[pos1+1]*(1-pr1);
 	               pos1--;
               } 
         break;
      }
   return(0);
  }
//+------------------------------------------------------------------+